# coding: utf-8

"""
    Inventory API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: inventory
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from linnworks_api.generated.inventory.models.scrap_item import ScrapItem
from typing import Optional, Set
from typing_extensions import Self

class AddScrapItemRequest(BaseModel):
    """
    AddScrapItemRequest
    """ # noqa: E501
    scrap_item: Optional[ScrapItem] = Field(default=None, alias="ScrapItem")
    location_id: Optional[StrictStr] = Field(default=None, alias="LocationId")
    ignore_consumption: Optional[StrictBool] = Field(default=None, description="Consumption should not be recorded for this scrap request", alias="IgnoreConsumption")
    __properties: ClassVar[List[str]] = ["ScrapItem", "LocationId", "IgnoreConsumption"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddScrapItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of scrap_item
        if self.scrap_item:
            _dict['ScrapItem'] = self.scrap_item.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddScrapItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ScrapItem": ScrapItem.from_dict(obj["ScrapItem"]) if obj.get("ScrapItem") is not None else None,
            "LocationId": obj.get("LocationId"),
            "IgnoreConsumption": obj.get("IgnoreConsumption")
        })
        return _obj


