# coding: utf-8

"""
    Listings API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: listings
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BigCommerceConfigAttributes(BaseModel):
    """
    BigCommerceConfigAttributes
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, alias="Name")
    type: Optional[StrictStr] = Field(default=None, alias="Type")
    max_length: Optional[StrictInt] = Field(default=None, alias="MaxLength")
    label: Optional[StrictStr] = Field(default=None, alias="Label")
    value: Optional[StrictStr] = Field(default=None, alias="Value")
    extended_property: Optional[StrictStr] = Field(default=None, alias="ExtendedProperty")
    default: Optional[StrictBool] = Field(default=None, alias="Default")
    __properties: ClassVar[List[str]] = ["Name", "Type", "MaxLength", "Label", "Value", "ExtendedProperty", "Default"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['STRING', 'BOOLEAN', 'INT', 'ENUM', 'DATE', 'HTML', 'DECIMAL', 'DEPENDED']):
            raise ValueError("must be one of enum values ('STRING', 'BOOLEAN', 'INT', 'ENUM', 'DATE', 'HTML', 'DECIMAL', 'DEPENDED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BigCommerceConfigAttributes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BigCommerceConfigAttributes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Name": obj.get("Name"),
            "Type": obj.get("Type"),
            "MaxLength": obj.get("MaxLength"),
            "Label": obj.get("Label"),
            "Value": obj.get("Value"),
            "ExtendedProperty": obj.get("ExtendedProperty"),
            "Default": obj.get("Default")
        })
        return _obj


