# coding: utf-8

"""
    Orders API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: orders
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetOrderPackagingCalculationRequest(BaseModel):
    """
    Request class for GetOrderPackagingCalculationRequest method in Orders controller
    """ # noqa: E501
    pk_order_ids: Optional[List[StrictStr]] = Field(default=None, description="List of order ids for which the packaging information should be returned, recalculated, saved", alias="pkOrderIds")
    recalculate: Optional[StrictBool] = Field(default=None, description="Flag to indicate that recalculation is necessary", alias="Recalculate")
    save_recalculation: Optional[StrictBool] = Field(default=None, description="Flag to indicate that after recalculation the results should be saved back to the database", alias="SaveRecalculation")
    __properties: ClassVar[List[str]] = ["pkOrderIds", "Recalculate", "SaveRecalculation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetOrderPackagingCalculationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetOrderPackagingCalculationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pkOrderIds": obj.get("pkOrderIds"),
            "Recalculate": obj.get("Recalculate"),
            "SaveRecalculation": obj.get("SaveRecalculation")
        })
        return _obj


