# coding: utf-8

"""
    Purchase Orders API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: purchaseorder
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ColumnPurchaseOrderMappingModel(BaseModel):
    """
    ColumnPurchaseOrderMappingModel
    """ # noqa: E501
    csv_field: Optional[StrictStr] = Field(default=None, alias="CsvField")
    index: Optional[StrictInt] = Field(default=None, alias="Index")
    linnworks_field_type: Optional[StrictStr] = Field(default=None, alias="LinnworksFieldType")
    __properties: ClassVar[List[str]] = ["CsvField", "Index", "LinnworksFieldType"]

    @field_validator('linnworks_field_type')
    def linnworks_field_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Sku', 'SupplierCode', 'SupplierBarcode', 'Title', 'PackSize', 'PackQuantity', 'Quantity', 'UnitCost', 'TaxRate', 'Tax', 'LineTotal']):
            raise ValueError("must be one of enum values ('Sku', 'SupplierCode', 'SupplierBarcode', 'Title', 'PackSize', 'PackQuantity', 'Quantity', 'UnitCost', 'TaxRate', 'Tax', 'LineTotal')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ColumnPurchaseOrderMappingModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ColumnPurchaseOrderMappingModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CsvField": obj.get("CsvField"),
            "Index": obj.get("Index"),
            "LinnworksFieldType": obj.get("LinnworksFieldType")
        })
        return _obj


