# coding: utf-8

"""
    Purchase Orders API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: purchaseorder
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from linnworks_api.generated.purchaseorder.models.column_purchase_order_mapping_model import ColumnPurchaseOrderMappingModel
from typing import Optional, Set
from typing_extensions import Self

class ExportPurchaseOrderSettingModel(BaseModel):
    """
    ExportPurchaseOrderSettingModel
    """ # noqa: E501
    column_mappings: Optional[List[ColumnPurchaseOrderMappingModel]] = Field(default=None, alias="ColumnMappings")
    delimiter: Optional[StrictStr] = Field(default=None, alias="Delimiter")
    encoding: Optional[StrictStr] = Field(default=None, alias="Encoding")
    purchase_id: Optional[StrictStr] = Field(default=None, alias="PurchaseId")
    string_delimiter: Optional[StrictStr] = Field(default=None, alias="StringDelimiter")
    file_name: Optional[StrictStr] = Field(default=None, alias="FileName")
    __properties: ClassVar[List[str]] = ["ColumnMappings", "Delimiter", "Encoding", "PurchaseId", "StringDelimiter", "FileName"]

    @field_validator('encoding')
    def encoding_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['UTF8', 'UTF16', 'UTF16BE', 'SHIFTJIS']):
            raise ValueError("must be one of enum values ('UTF8', 'UTF16', 'UTF16BE', 'SHIFTJIS')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExportPurchaseOrderSettingModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in column_mappings (list)
        _items = []
        if self.column_mappings:
            for _item_column_mappings in self.column_mappings:
                if _item_column_mappings:
                    _items.append(_item_column_mappings.to_dict())
            _dict['ColumnMappings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExportPurchaseOrderSettingModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ColumnMappings": [ColumnPurchaseOrderMappingModel.from_dict(_item) for _item in obj["ColumnMappings"]] if obj.get("ColumnMappings") is not None else None,
            "Delimiter": obj.get("Delimiter"),
            "Encoding": obj.get("Encoding"),
            "PurchaseId": obj.get("PurchaseId"),
            "StringDelimiter": obj.get("StringDelimiter"),
            "FileName": obj.get("FileName")
        })
        return _obj


