# coding: utf-8

"""
    Purchase Orders API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: purchaseorder
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from linnworks_api.generated.purchaseorder.models.common_purchase_order_header import CommonPurchaseOrderHeader
from linnworks_api.generated.purchaseorder.models.common_purchase_order_item import CommonPurchaseOrderItem
from typing import Optional, Set
from typing_extensions import Self

class UpdatePurchaseOrderItemResponse(BaseModel):
    """
    Response from update/add purchase order item, contains newly added purchase order item line and Purchase order header with recaluclated totals
    """ # noqa: E501
    new_purchase_order_item: Optional[CommonPurchaseOrderItem] = Field(default=None, alias="NewPurchaseOrderItem")
    purchase_order_header: Optional[CommonPurchaseOrderHeader] = Field(default=None, alias="PurchaseOrderHeader")
    batch_inventory_id: Optional[StrictInt] = Field(default=None, description="If the item was batched or booked into a WMS location, this is the batch inventory id for the booked in stock.   If an item was not delivered or was a non batched item, this will be null.", alias="BatchInventoryId")
    __properties: ClassVar[List[str]] = ["NewPurchaseOrderItem", "PurchaseOrderHeader", "BatchInventoryId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdatePurchaseOrderItemResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of new_purchase_order_item
        if self.new_purchase_order_item:
            _dict['NewPurchaseOrderItem'] = self.new_purchase_order_item.to_dict()
        # override the default output from pydantic by calling `to_dict()` of purchase_order_header
        if self.purchase_order_header:
            _dict['PurchaseOrderHeader'] = self.purchase_order_header.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdatePurchaseOrderItemResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "NewPurchaseOrderItem": CommonPurchaseOrderItem.from_dict(obj["NewPurchaseOrderItem"]) if obj.get("NewPurchaseOrderItem") is not None else None,
            "PurchaseOrderHeader": CommonPurchaseOrderHeader.from_dict(obj["PurchaseOrderHeader"]) if obj.get("PurchaseOrderHeader") is not None else None,
            "BatchInventoryId": obj.get("BatchInventoryId")
        })
        return _obj


