# coding: utf-8

"""
    Returns and Refunds API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: returnsrefunds
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from linnworks_api.generated.returnsrefunds.models.post_sale_sub_status import PostSaleSubStatus
from typing import Optional, Set
from typing_extensions import Self

class PostSaleStatus(BaseModel):
    """
    PostSaleStatus
    """ # noqa: E501
    status_header: Optional[StrictStr] = Field(default=None, alias="StatusHeader")
    status_detail: Optional[PostSaleSubStatus] = Field(default=None, alias="StatusDetail")
    __properties: ClassVar[List[str]] = ["StatusHeader", "StatusDetail"]

    @field_validator('status_header')
    def status_header_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['OPEN', 'PROCESSED', 'ERROR', 'ERROR_ACKED', 'PENDING']):
            raise ValueError("must be one of enum values ('OPEN', 'PROCESSED', 'ERROR', 'ERROR_ACKED', 'PENDING')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostSaleStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of status_detail
        if self.status_detail:
            _dict['StatusDetail'] = self.status_detail.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostSaleStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "StatusHeader": obj.get("StatusHeader"),
            "StatusDetail": PostSaleSubStatus.from_dict(obj["StatusDetail"]) if obj.get("StatusDetail") is not None else None
        })
        return _obj


