# coding: utf-8

"""
    Warehouse Transfer

    Warehouse Transfer v1

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WarehouseTransferStockItemModel(BaseModel):
    """
    WarehouseTransferStockItemModel
    """ # noqa: E501
    stock_item_id: Optional[StrictStr] = Field(default=None, description="Stock Item Guid", alias="stockItemId")
    stock_item_int_id: Optional[StrictInt] = Field(default=None, description="Stock Item integer Id", alias="stockItemIntId")
    item_number: Optional[StrictStr] = Field(default=None, description="SKU", alias="itemNumber")
    item_title: Optional[StrictStr] = Field(default=None, description="Item title", alias="itemTitle")
    from_available_quantity: Optional[StrictInt] = Field(default=None, description="Available (Ship from)", alias="fromAvailableQuantity")
    destination_available_quantity: Optional[StrictInt] = Field(default=None, description="Available (Destination Warehouse)", alias="destinationAvailableQuantity")
    from_due_quantity: Optional[StrictInt] = Field(default=None, description="Due (Ship From Warehouse)", alias="fromDueQuantity")
    thumbnail_source: Optional[StrictStr] = Field(default=None, alias="thumbnailSource")
    rows_count: Optional[StrictInt] = Field(default=None, alias="rowsCount")
    __properties: ClassVar[List[str]] = ["stockItemId", "stockItemIntId", "itemNumber", "itemTitle", "fromAvailableQuantity", "destinationAvailableQuantity", "fromDueQuantity", "thumbnailSource", "rowsCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WarehouseTransferStockItemModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if item_number (nullable) is None
        # and model_fields_set contains the field
        if self.item_number is None and "item_number" in self.model_fields_set:
            _dict['itemNumber'] = None

        # set to None if item_title (nullable) is None
        # and model_fields_set contains the field
        if self.item_title is None and "item_title" in self.model_fields_set:
            _dict['itemTitle'] = None

        # set to None if thumbnail_source (nullable) is None
        # and model_fields_set contains the field
        if self.thumbnail_source is None and "thumbnail_source" in self.model_fields_set:
            _dict['thumbnailSource'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WarehouseTransferStockItemModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "stockItemId": obj.get("stockItemId"),
            "stockItemIntId": obj.get("stockItemIntId"),
            "itemNumber": obj.get("itemNumber"),
            "itemTitle": obj.get("itemTitle"),
            "fromAvailableQuantity": obj.get("fromAvailableQuantity"),
            "destinationAvailableQuantity": obj.get("destinationAvailableQuantity"),
            "fromDueQuantity": obj.get("fromDueQuantity"),
            "thumbnailSource": obj.get("thumbnailSource"),
            "rowsCount": obj.get("rowsCount")
        })
        return _obj


